require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_ACPI_H)) {
    eval 'sub _ASM_ACPI_H () {1;}' unless defined(&_ASM_ACPI_H);
    if(defined(&__KERNEL__)) {
	eval 'sub COMPILER_DEPENDENT_INT64 () {\'long long\';}' unless defined(&COMPILER_DEPENDENT_INT64);
	eval 'sub COMPILER_DEPENDENT_UINT64 () {\'unsigned long long\';}' unless defined(&COMPILER_DEPENDENT_UINT64);
	eval 'sub ACPI_SYSTEM_XFACE () {1;}' unless defined(&ACPI_SYSTEM_XFACE);
	eval 'sub ACPI_EXTERNAL_XFACE () {1;}' unless defined(&ACPI_EXTERNAL_XFACE);
	eval 'sub ACPI_INTERNAL_XFACE () {1;}' unless defined(&ACPI_INTERNAL_XFACE);
	eval 'sub ACPI_INTERNAL_VAR_XFACE () {1;}' unless defined(&ACPI_INTERNAL_VAR_XFACE);
	eval 'sub ACPI_ASM_MACROS () {1;}' unless defined(&ACPI_ASM_MACROS);
	eval 'sub BREAKPOINT3 () {1;}' unless defined(&BREAKPOINT3);
	eval 'sub ACPI_DISABLE_IRQS () {
	    eval q( &__cli());
	}' unless defined(&ACPI_DISABLE_IRQS);
	eval 'sub ACPI_ENABLE_IRQS () {
	    eval q( &__sti());
	}' unless defined(&ACPI_ENABLE_IRQS);
	eval 'sub ACPI_FLUSH_CPU_CACHE () {
	    eval q( &wbinvd());
	}' unless defined(&ACPI_FLUSH_CPU_CACHE);
	eval 'sub ACPI_ACQUIRE_GLOBAL_LOCK {
	    my($GLptr, $Acq) = @_;
    	    eval q( &do { \'int\'  &dummy;  &asm(\\"1:     movl (%1),%%eax;\\" \\"movl   %%eax,%%edx;\\" \\"andl   %2,%%edx;\\" \\"btsl   $0x1,%%edx;\\" \\"adcl   $0x0,%%edx;\\" \\"lock;  cmpxchgl %%edx,(%1);\\" \\"jnz    1b;\\" \\"cmpb   $0x3,%%dl;\\" \\"sbbl   %%eax,%%eax\\" :\\"=a\\"($Acq),\\"=c\\"( &dummy):\\"c\\"($GLptr),\\"i\\"(~1):\\"dx\\"); }  &while(0));
	}' unless defined(&ACPI_ACQUIRE_GLOBAL_LOCK);
	eval 'sub ACPI_RELEASE_GLOBAL_LOCK {
	    my($GLptr, $Acq) = @_;
    	    eval q( &do { \'int\'  &dummy;  &asm(\\"1:     movl (%1),%%eax;\\" \\"movl   %%eax,%%edx;\\" \\"andl   %2,%%edx;\\" \\"lock;  cmpxchgl %%edx,(%1);\\" \\"jnz    1b;\\" \\"andl   $0x1,%%eax\\" :\\"=a\\"($Acq),\\"=c\\"( &dummy):\\"c\\"($GLptr),\\"i\\"(~3):\\"dx\\"); }  &while(0));
	}' unless defined(&ACPI_RELEASE_GLOBAL_LOCK);
	eval 'sub ACPI_DIV_64_BY_32 {
	    my($n_hi, $n_lo, $d32, $q32, $r32) = @_;
    	    eval q( &asm(\\"divl %2;\\" :\\"=a\\"($q32), \\"=d\\"($r32) :\\"r\\"($d32), \\"0\\"($n_lo), \\"1\\"($n_hi)));
	}' unless defined(&ACPI_DIV_64_BY_32);
	eval 'sub ACPI_SHIFT_RIGHT_64 {
	    my($n_hi, $n_lo) = @_;
    	    eval q( &asm(\\"shrl   $1,%2;\\" \\"rcrl   $1,%3;\\" :\\"=r\\"($n_hi), \\"=r\\"($n_lo) :\\"0\\"($n_hi), \\"1\\"($n_lo)));
	}' unless defined(&ACPI_SHIFT_RIGHT_64);
	if(defined(&CONFIG_ACPI_HT_ONLY)) {
	    eval 'sub acpi_ioapic () {0;}' unless defined(&acpi_ioapic);
	} else {
	    if(defined(&CONFIG_ACPI_BOOT)) {
		eval 'sub FIX_ACPI_PAGES () {4;}' unless defined(&FIX_ACPI_PAGES);
		if(defined(&CONFIG_X86_IO_APIC)) {
		    eval 'sub disable_ioapic_setup {
		        my($void) = @_;
    			eval q({  &skip_ioapic_setup = 1; });
		    }' unless defined(&disable_ioapic_setup);
		    eval 'sub ioapic_setup_disabled {
		        my($void) = @_;
    			eval q({  &skip_ioapic_setup; });
		    }' unless defined(&ioapic_setup_disabled);
		} else {
		    eval 'sub disable_ioapic_setup {
		        my($void) = @_;
    			eval q({ });
		    }' unless defined(&disable_ioapic_setup);
		}
	    } else {
		eval 'sub acpi_lapic () {0;}' unless defined(&acpi_lapic);
		eval 'sub acpi_ioapic () {0;}' unless defined(&acpi_ioapic);
	    }
	}
	if(defined(&CONFIG_ACPI_SLEEP)) {
	    eval 'sub acpi_save_register_state {
	        my($return_point) = @_;
    		eval q({  &saved_eip = $return_point;  &asm  &volatile (\\"movl %%esp,(%0)\\" : \\"=m\\" ( &saved_esp));  &asm  &volatile (\\"movl %%ebp,(%0)\\" : \\"=m\\" ( &saved_ebp));  &asm  &volatile (\\"movl %%ebx,(%0)\\" : \\"=m\\" ( &saved_ebx));  &asm  &volatile (\\"movl %%edi,(%0)\\" : \\"=m\\" ( &saved_edi));  &asm  &volatile (\\"movl %%esi,(%0)\\" : \\"=m\\" ( &saved_esi)); });
	    }' unless defined(&acpi_save_register_state);
	    eval 'sub acpi_restore_register_state () {
	        eval q( &do {}  &while (0));
	    }' unless defined(&acpi_restore_register_state);
	}
    }
}
1;
