require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IO_H)) {
    eval 'sub _ASM_IO_H () {1;}' unless defined(&_ASM_IO_H);
    require 'linux/config.ph';
    eval 'sub IO_SPACE_LIMIT () {0xffff;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub XQUAD_PORTIO_BASE () {0xfe400000;}' unless defined(&XQUAD_PORTIO_BASE);
    eval 'sub XQUAD_PORTIO_QUAD () {0x40000;}' unless defined(&XQUAD_PORTIO_QUAD);
    eval 'sub XQUAD_PORTIO_LEN () {0x80000;}' unless defined(&XQUAD_PORTIO_LEN);
    if(defined(&__KERNEL__)) {
	require 'linux/vmalloc.ph';
	if((defined(&CONFIG_DEBUG_IOVIRT) ? &CONFIG_DEBUG_IOVIRT : 0)) {
	    eval 'sub __io_virt {
	        my($x) = @_;
    		eval q( &__io_virt_debug(($x),  &__FILE__,  &__LINE__));
	    }' unless defined(&__io_virt);
	} else {
	    eval 'sub __io_virt {
	        my($x) = @_;
    		eval q((( &void *)($x)));
	    }' unless defined(&__io_virt);
	}
	if(defined(&CONFIG_HIGHMEM64G)) {
	    eval 'sub page_to_phys {
	        my($page) = @_;
    		eval q((( &u64)($page -  &mem_map) <<  &PAGE_SHIFT));
	    }' unless defined(&page_to_phys);
	} else {
	    eval 'sub page_to_phys {
	        my($page) = @_;
    		eval q((($page -  &mem_map) <<  &PAGE_SHIFT));
	    }' unless defined(&page_to_phys);
	}
	eval 'sub virt_to_bus () { &virt_to_phys;}' unless defined(&virt_to_bus);
	eval 'sub bus_to_virt () { &phys_to_virt;}' unless defined(&bus_to_virt);
	eval 'sub page_to_bus () { &page_to_phys;}' unless defined(&page_to_bus);
	eval 'sub readb {
	    my($addr) = @_;
    	    eval q((*( &volatile \'unsigned char\' *)  &__io_virt($addr)));
	}' unless defined(&readb);
	eval 'sub readw {
	    my($addr) = @_;
    	    eval q((*( &volatile \'unsigned short\' *)  &__io_virt($addr)));
	}' unless defined(&readw);
	eval 'sub readl {
	    my($addr) = @_;
    	    eval q((*( &volatile \'unsigned int\' *)  &__io_virt($addr)));
	}' unless defined(&readl);
	eval 'sub __raw_readb () { &readb;}' unless defined(&__raw_readb);
	eval 'sub __raw_readw () { &readw;}' unless defined(&__raw_readw);
	eval 'sub __raw_readl () { &readl;}' unless defined(&__raw_readl);
	eval 'sub writeb {
	    my($b,$addr) = @_;
    	    eval q((*( &volatile \'unsigned char\' *)  &__io_virt($addr) = ($b)));
	}' unless defined(&writeb);
	eval 'sub writew {
	    my($b,$addr) = @_;
    	    eval q((*( &volatile \'unsigned short\' *)  &__io_virt($addr) = ($b)));
	}' unless defined(&writew);
	eval 'sub writel {
	    my($b,$addr) = @_;
    	    eval q((*( &volatile \'unsigned int\' *)  &__io_virt($addr) = ($b)));
	}' unless defined(&writel);
	eval 'sub __raw_writeb () { &writeb;}' unless defined(&__raw_writeb);
	eval 'sub __raw_writew () { &writew;}' unless defined(&__raw_writew);
	eval 'sub __raw_writel () { &writel;}' unless defined(&__raw_writel);
	eval 'sub memset_io {
	    my($a,$b,$c) = @_;
    	    eval q( &__memset( &__io_virt($a),($b),($c)));
	}' unless defined(&memset_io);
	eval 'sub memcpy_fromio {
	    my($a,$b,$c) = @_;
    	    eval q( &__memcpy(($a), &__io_virt($b),($c)));
	}' unless defined(&memcpy_fromio);
	eval 'sub memcpy_toio {
	    my($a,$b,$c) = @_;
    	    eval q( &__memcpy( &__io_virt($a),($b),($c)));
	}' unless defined(&memcpy_toio);
	eval 'sub __ISA_IO_base () {(( &PAGE_OFFSET));}' unless defined(&__ISA_IO_base);
	eval 'sub isa_readb {
	    my($a) = @_;
    	    eval q( &readb( &__ISA_IO_base + ($a)));
	}' unless defined(&isa_readb);
	eval 'sub isa_readw {
	    my($a) = @_;
    	    eval q( &readw( &__ISA_IO_base + ($a)));
	}' unless defined(&isa_readw);
	eval 'sub isa_readl {
	    my($a) = @_;
    	    eval q( &readl( &__ISA_IO_base + ($a)));
	}' unless defined(&isa_readl);
	eval 'sub isa_writeb {
	    my($b,$a) = @_;
    	    eval q( &writeb($b, &__ISA_IO_base + ($a)));
	}' unless defined(&isa_writeb);
	eval 'sub isa_writew {
	    my($w,$a) = @_;
    	    eval q( &writew($w, &__ISA_IO_base + ($a)));
	}' unless defined(&isa_writew);
	eval 'sub isa_writel {
	    my($l,$a) = @_;
    	    eval q( &writel($l, &__ISA_IO_base + ($a)));
	}' unless defined(&isa_writel);
	eval 'sub isa_memset_io {
	    my($a,$b,$c) = @_;
    	    eval q( &memset_io( &__ISA_IO_base + ($a),($b),($c)));
	}' unless defined(&isa_memset_io);
	eval 'sub isa_memcpy_fromio {
	    my($a,$b,$c) = @_;
    	    eval q( &memcpy_fromio(($a), &__ISA_IO_base + ($b),($c)));
	}' unless defined(&isa_memcpy_fromio);
	eval 'sub isa_memcpy_toio {
	    my($a,$b,$c) = @_;
    	    eval q( &memcpy_toio( &__ISA_IO_base + ($a),($b),($c)));
	}' unless defined(&isa_memcpy_toio);
	eval 'sub eth_io_copy_and_sum {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &eth_copy_and_sum(($a), &__io_virt($b),($c),($d)));
	}' unless defined(&eth_io_copy_and_sum);
	eval 'sub isa_eth_io_copy_and_sum {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &eth_copy_and_sum(($a), &__io_virt( &__ISA_IO_base + ($b)),($c),($d)));
	}' unless defined(&isa_eth_io_copy_and_sum);
	if(defined( &CONFIG_X86_OOSTORE) || defined( &CONFIG_X86_PPRO_FENCE)) {
	    eval 'sub flush_write_buffers {
	        my($void) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&flush_write_buffers);
	    eval 'sub dma_cache_inv {
	        my($_start,$_size) = @_;
    		eval q( &flush_write_buffers());
	    }' unless defined(&dma_cache_inv);
	    eval 'sub dma_cache_wback {
	        my($_start,$_size) = @_;
    		eval q( &flush_write_buffers());
	    }' unless defined(&dma_cache_wback);
	    eval 'sub dma_cache_wback_inv {
	        my($_start,$_size) = @_;
    		eval q( &flush_write_buffers());
	    }' unless defined(&dma_cache_wback_inv);
	} else {
	    eval 'sub dma_cache_inv {
	        my($_start,$_size) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&dma_cache_inv);
	    eval 'sub dma_cache_wback {
	        my($_start,$_size) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&dma_cache_wback);
	    eval 'sub dma_cache_wback_inv {
	        my($_start,$_size) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&dma_cache_wback_inv);
	    eval 'sub flush_write_buffers () {
	        eval q();
	    }' unless defined(&flush_write_buffers);
	}
    }
    if(defined(&SLOW_IO_BY_JUMPING)) {
	eval 'sub __SLOW_DOWN_IO () {"\\njmp 1f\\n1:\\tjmp 1f\\n1:";}' unless defined(&__SLOW_DOWN_IO);
    } else {
	eval 'sub __SLOW_DOWN_IO () {"\\noutb %%al,$0x80";}' unless defined(&__SLOW_DOWN_IO);
    }
    if(defined(&REALLY_SLOW_IO)) {
	eval 'sub __FULL_SLOW_DOWN_IO () { &__SLOW_DOWN_IO  &__SLOW_DOWN_IO  &__SLOW_DOWN_IO  &__SLOW_DOWN_IO;}' unless defined(&__FULL_SLOW_DOWN_IO);
    } else {
	eval 'sub __FULL_SLOW_DOWN_IO () { &__SLOW_DOWN_IO;}' unless defined(&__FULL_SLOW_DOWN_IO);
    }
    if(defined(&CONFIG_MULTIQUAD)) {
    }
    eval 'sub __OUT1 {
        my($s,$x) = @_;
	    eval q( &static  &inline  &void  &out$s(\'unsigned x value\', \'unsigned short port\') {);
    }' unless defined(&__OUT1);
    eval 'sub __OUT2 {
        my($s,$s1,$s2) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__OUT2);
    if(defined ( &CONFIG_MULTIQUAD)  && !defined( &STANDALONE)) {
	eval 'sub __OUTQ {
	    my($s,$ss,$x) = @_;
    	    eval q( &static  &inline  &void  &out$ss(\'unsigned x value\', \'unsigned short port\') {  &if ( &xquad_portio)  &write$s( &value,  &xquad_portio +  &port);  &else  &out$ss &_local( &value,  &port); }  &static  &inline  &void  &out$ss &_quad(\'unsigned x value\', \'unsigned short port\', \'int\'  &quad) {  &if ( &xquad_portio)  &write$s( &value,  &xquad_portio + ( &XQUAD_PORTIO_QUAD* &quad) +  &port); });
	}' unless defined(&__OUTQ);
	eval 'sub __INQ {
	    my($s,$ss) = @_;
    	    eval q( &static  &inline  &RETURN_TYPE  &in$ss {  &if ( &xquad_portio)  &return  &read$s(  &xquad_portio +  &port);  &else  &return  &in$ss &_local( &port); }  &static  &inline  &RETURN_TYPE  &in$ss &_quad(\'unsigned short port\', \'int\'  &quad) {  &if ( &xquad_portio)  &return  &read$s(  &xquad_portio + ( &XQUAD_PORTIO_QUAD* &quad) +  &port);  &else  &return 0;});
	}' unless defined(&__INQ);
    }
    if(!defined( &CONFIG_MULTIQUAD) || defined( &STANDALONE)) {
	eval 'sub __OUT {
	    my($s,$s1,$x) = @_;
    	    eval q( &__OUT1($s,$x)  &__OUT2($s,$s1,\\"w\\") : : \\"a\\" ( &value), \\"Nd\\" ( &port)); }  &__OUT1($s &_p,$x)  &__OUT2($s,$s1,\\"w\\")  &__FULL_SLOW_DOWN_IO : : \\"a\\" ( &value), \\"Nd\\" ( &port));});
	}' unless defined(&__OUT);
    } else {
	eval 'sub __OUT {
	    my($s,$s1,$x) = @_;
    	    eval q( &__OUT1($s &_local,$x)  &__OUT2($s,$s1,\\"w\\") : : \\"a\\" ( &value), \\"Nd\\" ( &port)); }  &__OUT1($s &_p_local,$x)  &__OUT2($s,$s1,\\"w\\")  &__FULL_SLOW_DOWN_IO : : \\"a\\" ( &value), \\"Nd\\" ( &port));}  &__OUTQ($s,$s,$x)  &__OUTQ($s,$s &_p,$x));
	}' unless defined(&__OUT);
    }
    eval 'sub __IN1 {
        my($s) = @_;
	    eval q( &static  &inline  &RETURN_TYPE  &in$s {  &RETURN_TYPE  &_v;);
    }' unless defined(&__IN1);
    eval 'sub __IN2 {
        my($s,$s1,$s2) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__IN2);
    if(!defined( &CONFIG_MULTIQUAD) || defined( &STANDALONE)) {
	eval 'sub __IN () {( &s, &s1, &i...)  &__IN1( &s)  &__IN2( &s, &s1,"w") : "=a" ( &_v) : "Nd" ( &port) , &i );  &return  &_v; }  &__IN1( &s &_p)  &__IN2( &s, &s1,"w")  &__FULL_SLOW_DOWN_IO : "=a" ( &_v) : "Nd" ( &port) , &i );  &return  &_v; };}' unless defined(&__IN);
    } else {
	eval 'sub __IN () {( &s, &s1, &i...)  &__IN1( &s &_local)  &__IN2( &s, &s1,"w") : "=a" ( &_v) : "Nd" ( &port) , &i );  &return  &_v; }  &__IN1( &s &_p_local)  &__IN2( &s, &s1,"w")  &__FULL_SLOW_DOWN_IO : "=a" ( &_v) : "Nd" ( &port) , &i );  &return  &_v; }  &__INQ( &s, &s)  &__INQ( &s, &s &_p);}' unless defined(&__IN);
    }
    eval 'sub __INS {
        my($s) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__INS);
    eval 'sub __OUTS {
        my($s) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__OUTS);
    eval 'sub RETURN_TYPE () {\'unsigned char\';}' unless defined(&RETURN_TYPE);
    undef(&RETURN_TYPE) if defined(&RETURN_TYPE);
    eval 'sub RETURN_TYPE () {\'unsigned short\';}' unless defined(&RETURN_TYPE);
    undef(&RETURN_TYPE) if defined(&RETURN_TYPE);
    eval 'sub RETURN_TYPE () {\'unsigned int\';}' unless defined(&RETURN_TYPE);
    undef(&RETURN_TYPE) if defined(&RETURN_TYPE);
}
1;
