require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_I386_PAGE_H)) {
    eval 'sub _I386_PAGE_H () {1;}' unless defined(&_I386_PAGE_H);
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'linux/config.ph';
	    if(defined(&CONFIG_X86_USE_3DNOW)) {
		require 'asm/mmx.ph';
		eval 'sub clear_page {
		    my($page) = @_;
    		    eval q( &mmx_clear_page(( &void *)($page)));
		}' unless defined(&clear_page);
		eval 'sub copy_page {
		    my($to,$from) = @_;
    		    eval q( &mmx_copy_page($to,$from));
		}' unless defined(&copy_page);
	    } else {
		eval 'sub clear_page {
		    my($page) = @_;
    		    eval q( &memset(( &void *)($page), 0,  &PAGE_SIZE));
		}' unless defined(&clear_page);
		eval 'sub copy_page {
		    my($to,$from) = @_;
    		    eval q( &memcpy(( &void *)($to), ( &void *)($from),  &PAGE_SIZE));
		}' unless defined(&copy_page);
	    }
	    eval 'sub clear_user_page {
	        my($page, $vaddr) = @_;
    		eval q( &clear_page($page));
	    }' unless defined(&clear_user_page);
	    eval 'sub copy_user_page {
	        my($to, $from, $vaddr) = @_;
    		eval q( &copy_page($to, $from));
	    }' unless defined(&copy_user_page);
	    if((defined(&CONFIG_X86_PAE) ? &CONFIG_X86_PAE : 0)) {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q((. &pte_low | (($x). &pte_high << 32)));
		}' unless defined(&pte_val);
	    } else {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q((($x). &pte_low));
		}' unless defined(&pte_val);
	    }
	    eval 'sub PTE_MASK () { &PAGE_MASK;}' unless defined(&PTE_MASK);
	    eval 'sub pmd_val {
	        my($x) = @_;
    		eval q((($x). &pmd));
	    }' unless defined(&pmd_val);
	    eval 'sub pgd_val {
	        my($x) = @_;
    		eval q((($x). &pgd));
	    }' unless defined(&pgd_val);
	    eval 'sub pgprot_val {
	        my($x) = @_;
    		eval q((($x). &pgprot));
	    }' unless defined(&pgprot_val);
	    eval 'sub __pte {
	        my($x) = @_;
    		eval q((( &pte_t) { ($x) } ));
	    }' unless defined(&__pte);
	    eval 'sub __pmd {
	        my($x) = @_;
    		eval q((( &pmd_t) { ($x) } ));
	    }' unless defined(&__pmd);
	    eval 'sub __pgd {
	        my($x) = @_;
    		eval q((( &pgd_t) { ($x) } ));
	    }' unless defined(&__pgd);
	    eval 'sub __pgprot {
	        my($x) = @_;
    		eval q((( &pgprot_t) { ($x) } ));
	    }' unless defined(&__pgprot);
	}
	eval 'sub PAGE_ALIGN {
	    my($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub __PAGE_OFFSET () {(0xc0000000);}' unless defined(&__PAGE_OFFSET);
	eval 'sub __VMALLOC_RESERVE () {(128<< 20);}' unless defined(&__VMALLOC_RESERVE);
	unless(defined(&__ASSEMBLY__)) {
	    if(1) {
		eval 'sub BUG () {
		    eval q(\\"(assembly code)\\");
		}' unless defined(&BUG);
	    } else {
		eval 'sub BUG () {
		    eval q(\\"(assembly code)\\");
		}' unless defined(&BUG);
	    }
	    eval 'sub PAGE_BUG {
	        my($page) = @_;
    		eval q( &do {  &BUG(); }  &while (0));
	    }' unless defined(&PAGE_BUG);
	}
	eval 'sub PAGE_OFFSET () {( &__PAGE_OFFSET);}' unless defined(&PAGE_OFFSET);
	eval 'sub VMALLOC_RESERVE () {( &__VMALLOC_RESERVE);}' unless defined(&VMALLOC_RESERVE);
	eval 'sub __MAXMEM () {(- &__PAGE_OFFSET- &__VMALLOC_RESERVE);}' unless defined(&__MAXMEM);
	eval 'sub MAXMEM () {((- &PAGE_OFFSET- &VMALLOC_RESERVE));}' unless defined(&MAXMEM);
	eval 'sub __pa {
	    my($x) = @_;
    	    eval q((($x)- &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    my($x) = @_;
    	    eval q((( &void *)(($x)+ &PAGE_OFFSET)));
	}' unless defined(&__va);
	eval 'sub virt_to_page {
	    my($kaddr) = @_;
    	    eval q(( &mem_map + ( &__pa($kaddr) >>  &PAGE_SHIFT)));
	}' unless defined(&virt_to_page);
	eval 'sub VALID_PAGE {
	    my($page) = @_;
    	    eval q((($page -  &mem_map) <  &max_mapnr));
	}' unless defined(&VALID_PAGE);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
    }
}
1;
